# -*- coding: utf-8 -*-
# Filename: defineThread.py

from PyQt4.QtCore import QThread
from PyQt4.QtGui import QApplication
from engines import *
from players import *
from players.playerBase import Status
from defineEvent import *
import dbus
from dbus.mainloop.glib import DBusGMainLoop
import gobject


class searchNetThread(QThread):
	
	def __init__(self, receiver, artist, title, locale, proxy, engine, t = True):
		QThread.__init__(self)
		self.receiver = receiver
		self.artist = artist
		self.title = title
		self.locale = locale
		self.proxy = proxy
		self.engine = engine
		self.t = t
	
	def run(self):
		exec 'p = %s.%s(self.proxy, self.locale)' %(self.engine, self.engine)
		
		originalLrc, timeOut = p.request(self.artist, self.title)

		if(originalLrc is None):
			self.sleep(1)
			ev = netEvent(None, timeOut, p.netEncoder)
			QApplication.postEvent(self.receiver, ev)
		else:
			#print originalLrc[0][2]
			if(self.t):
				if(len(originalLrc) == 1):
					originalLrc, timeOut = p.downIt(originalLrc[0][2])
					self.sleep(1)
					ev = netEvent(originalLrc, timeOut, p.netEncoder)
					QApplication.postEvent(self.receiver, ev)
				else:
					self.sleep(1)
					ev = userChooseEvent(originalLrc, self.engine)
					QApplication.postEvent(self.receiver, ev)
			else:
				ev = userChooseEvent(originalLrc, self.engine)
				QApplication.postEvent(self.receiver, ev)

class dacThread(QThread):#down after choose thread
	
	def __init__(self,receiver,url,proxy,engine,fromAdvDown = False):
		QThread.__init__(self)
		self.receiver = receiver
		self.url = url
		self.proxy = proxy
		self.engine = engine
		self.fromAdvDown = fromAdvDown
	
	def run(self):
		if(self.engine == None):
			p = engine.engine(self.proxy)
		else:
			exec 'p = %s.%s(self.proxy)' %(self.engine, self.engine)

		originalLrc, timeOut = p.downIt(self.url)
		ev = netEvent(originalLrc, timeOut, p.netEncoder, self.fromAdvDown)
		QApplication.postEvent(self.receiver, ev)
		

class listenThread(QThread):
	
	def __init__(self, receiver, player):
		QThread.__init__(self)
		self.receiver = receiver
		self.player = player
		
	def statusCallback(self,arg,startup = False):
		if startup:
			playerSignal = 'startup'
		else:
			playerSignal = 'engineStateChange'
		if arg == Status().Playing:
			playerStatus = 'playing'
			self.sleep(1)
		elif arg == Status().Stopped:
			playerStatus = 'stop'
		else:
			playerStatus = 'pause'
		ev = playerEvent(playerSignal, playerStatus)
		QApplication.postEvent(self.receiver, ev)
	
	def run(self):
		#DBusGMainLoop(set_as_default = True)
		if self.player != None:
			exec "self.handler = %s.%s()" % (self.player, self.player)
			self.handler.onStatusChange(self.statusCallback)
			self.statusCallback(self.handler.getStatus(), True)
			mainloop = gobject.MainLoop()
		else:
			raise RuntimeError("Player not supplied")
		#time.sleep(1)
		
