# -*- coding: utf-8 -*-
# Filename:  juk.py

import time
from playerBase import Status
from dbusplayer import dbusPlayer

class juk(dbusPlayer):
	
	def __init__(self):
		self.process = "juk"
		dbusPlayer.__init__(self,"juk","org.kde.juk","/Player","org.kde.juk.player")
		self.iface.proxy_object._bus.add_signal_receiver(
			self.statusChanged,
			signal_name="newOutputAvailable",
			dbus_interface="org.kde.Phonon.AudioOutput",
			bus_name="org.kde.juk")
		#the following only works if the user changes manually the song
		self.iface.connect_to_signal("trackChanged", self.statusChanged)
	
	#TRACK SECTION
	def getTitle(self):
		return self.iface.trackProperty("Title")
	
	def getArtist(self):
		return self.iface.trackProperty("Artist")
	
	def getTimePoint(self):
		return self.handleTime(self.iface.currentTime()*1000)
	
	def getMediaFile(self):
		return self.iface.trackProperty("Path")
	
	#PLAYER SECTION
	def getStatus(self):
		return self.toStatus(self.iface.status())
		
	def playFunc(self):
		self.iface.play()
	
	def pauseFunc(self):
		self.iface.pause()
	
	def stopFunc(self):
		self.iface.stop()
	
	def prevFunc(self):
		self.iface.back()
	
	def nextFunc(self):
		self.iface.forward()
	
	#EVENTS SECTION
	def toStatus(self,status):
		if status == 2:
			return Status().Playing
		elif status == 1:
			return Status().Paused
		else:
			return Status().Stopped
	
	def statusChanged(self,*arg):
		if self.callback != None:
			if not arg or len(arg) > 1:
				try:
					time.sleep(0.2)
				except:
					pass
				arg = self.getStatus()
			else:
				arg = self.toStatus(arg)
			self.callback(arg)
