# -*- coding: utf-8 -*-
# Filename:  xmms2.py

from playerBase import Status
from dbusplayer import dbusPlayer

class xmms2(dbusPlayer):
	
	def __init__(self):
		self.process = "xmms2d"
		dbusPlayer.__init__(self,"xmms2","org.mpris.xmms2","/Player","org.freedesktop.MediaPlayer")
		self.iface.connect_to_signal("StatusChange", self.statusChanged)
		self.iface.connect_to_signal("TrackChange", self.trackChanged)

	#TRACK SECTION
	def getTitle(self):
		try:
			return self.iface.GetMetadata()['title']
		except KeyError:
			return ""
	
	def getArtist(self):
		try:
			return self.iface.GetMetadata()['artist']
		except KeyError:
			return ""
	
	def getTimePoint(self):#precision to second, try using handleTime
		return self.iface.PositionGet()
	
	def getMediaFile(self):
		try:
			return self.iface.GetMetadata()['location']
		except KeyError:
			return ""
	
	#PLAYER SECTION
	def getStatus(self):
		return self.toStatus(self.iface.GetStatus())
		
	def playFunc(self):
		self.iface.Play()
	
	def pauseFunc(self):
		self.iface.Pause()
	
	def stopFunc(self):
		self.iface.Stop()
	
	def prevFunc(self):
		self.iface.Prev()
	
	def nextFunc(self):
		self.iface.Next()
	
	#EVENTS SECTION
	def toStatus(self,status):
		if not status in range(3):
			status = status[0]
		return {0:Status().Playing,1:Status().Paused,2:Status().Stopped}[status]
	
	def statusChanged(self,arg):
		if self.callback == None:
			return
		self.callback(self.toStatus(arg))
	
	def trackChanged(self, arg):
		self.statusChanged(self.iface.GetStatus()) 
