# -*- coding: utf-8 -*-
# Filename: preferenceLaunchPlayer.py

from PyQt4.QtGui import *
from PyQt4.QtCore import *
from players import supportedPlayers
import os


class preferenceLaunchPlayer(QWidget):
	
	def __init__(self, parent = None, *args):
		QWidget.__init__(self, parent)
		
		self.supportPlayer = supportedPlayers
		mainLayout = QVBoxLayout(None)
		mainLayout.setContentsMargins(5, 10, 100, 240)
		#mainLayout.setContentsMargins(5,5,80,240)
		
		layout1 = QVBoxLayout(None)
		layout1.setContentsMargins(0,0,0,30)
		layout2 = QHBoxLayout(None)
		layout2.setContentsMargins(0, 0, 120, 0)
		self.playerLabel = QLabel(_('Please choose a player:'), self)
		self.playerList = QComboBox(self)
		for i in self.supportPlayer:
			self.playerList.addItem(i)
		layout2.addWidget(self.playerLabel)
		layout2.addWidget(self.playerList)
		
		self.pathBox = QLineEdit(self)
		layout1.addLayout(layout2)
		layout1.addWidget(self.pathBox)
		
		self.rememberPlayer = QCheckBox(_('Always launch the chosen player'), self)
		
		mainLayout.addLayout(layout1)
		mainLayout.addWidget(self.rememberPlayer)
		self.setLayout(mainLayout)
		
		self.connect(self.playerList, SIGNAL('activated(QString)'), self.changePath)
		self.connect(self.pathBox, SIGNAL('textChanged(QString)'), self.checkPath)
		
	def changePath(self, e):
		if(e == 'xmms2'):
			e = 'xmms2-launcher'
		te = '/usr/bin/%s' %e
		te = QString(te)
		self.pathBox.setText(te)
		self.checkPath(te)
		
	def checkPath(self, t):
		t = str(t.toLocal8Bit())
		if(os.path.isfile(t)):
			color = QColor(255,255,255)
		else:
			color = QColor(255,224,224)
		pl = QPalette()
		pl.setColor(QPalette.Window, color)
		pl.setColor(QPalette.Base, color)
		self.pathBox.setPalette(pl)
		
		p = t.split('/')[-1]
		if(p in self.supportPlayer and p != str(self.playerList.currentText())):
			self.playerList.setCurrentIndex(self.supportPlayer.index(p))